gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.SizeGroup

Contents

- Exported types
- Methods
  - addWidget
  - getIgnoreHidden
  - getMode
  - getWidgets
  - new
  - removeWidget
  - setIgnoreHidden
  - setMode
- Properties
  - ignoreHidden
  - mode

Description

`SizeGroup` provides a mechanism for grouping a number of widgets together so they all request the same amount of space. This is typically useful when you want a column of widgets to have the same size, but you can’t use a `Grid` widget.

In detail, the size requested for each widget in a `SizeGroup` is the maximum of the sizes that would have been requested for each widget in the size group if they were not in the size group. The mode of the size group (see `sizeGroupSetMode`) determines whether this applies to the horizontal size, the vertical size, or both sizes.

Note that size groups only affect the amount of space requested, not the size that the widgets finally receive. If you want the widgets in a `SizeGroup` to actually be the same size, you need to pack them in such a way that they get the size they request and not more. For example, if you are packing your widgets into a table, you would not include the `AttachOptionsFill` flag.

`SizeGroup` objects are referenced by each widget in the size group, so once you have added all widgets to a `SizeGroup`, you can drop the initial reference to the size group with `objectUnref`. If the widgets in the size group are subsequently destroyed, then they will be removed from the size group and drop their references on the size group; when all widgets have been removed, the size group will be freed.

Widgets can be part of multiple size groups; GTK+ will compute the horizontal size of a widget from the horizontal requisition of all widgets that can be reached from the widget by a chain of size groups of type `SizeGroupModeHorizontal` or `SizeGroupModeBoth`, and the vertical size from the vertical requisition of all widgets that can be reached from the widget by a chain of size groups of type `SizeGroupModeVertical` or `SizeGroupModeBoth`.

Note that only non-contextual sizes of every widget are ever consulted by size groups (since size groups have no knowledge of what size a widget will be allocated in one dimension, it cannot derive how much height a widget will receive for a given width). When grouping widgets that trade height for width in mode `SizeGroupModeVertical` or `SizeGroupModeBoth`: the height for the minimum width will be the requested height for all widgets in the group. The same is of course true when horizontally grouping width for height widgets.

Widgets that trade height-for-width should set a reasonably large minimum width by way of Label:widthChars for instance. Widgets with static sizes as well as widgets that grow (such as ellipsizing text) need no such considerations.

# GtkSizeGroup as GtkBuildable

Size groups can be specified in a UI definition by placing an `<object>` element with `class="GtkSizeGroup"` somewhere in the UI definition. The widgets that belong to the size group are specified by a `<widgets>` element that may contain multiple `<widget>` elements, one for each member of the size group. The ”name” attribute gives the id of the widget.

An example of a UI definition fragment with GtkSizeGroup:

### xml code

    <object class="GtkSizeGroup">
      <property name="mode">GTK_SIZE_GROUP_HORIZONTAL</property>
      <widgets>
        <widget name="radio1"/>
        <widget name="radio2"/>
      </widgets>
    </object>

Synopsis

- newtype SizeGroup = SizeGroup (ManagedPtr SizeGroup)
- class (GObject o, IsDescendantOf SizeGroup o) => IsSizeGroup o
- toSizeGroup :: (MonadIO m, IsSizeGroup o) => o -> m SizeGroup
- sizeGroupAddWidget :: (HasCallStack, MonadIO m, IsSizeGroup a, IsWidget b) => a -> b -> m ()
- sizeGroupGetIgnoreHidden :: (HasCallStack, MonadIO m, IsSizeGroup a) => a -> m Bool
- sizeGroupGetMode :: (HasCallStack, MonadIO m, IsSizeGroup a) => a -> m SizeGroupMode
- sizeGroupGetWidgets :: (HasCallStack, MonadIO m, IsSizeGroup a) => a -> m [Widget]
- sizeGroupNew :: (HasCallStack, MonadIO m) => SizeGroupMode -> m SizeGroup
- sizeGroupRemoveWidget :: (HasCallStack, MonadIO m, IsSizeGroup a, IsWidget b) => a -> b -> m ()
- sizeGroupSetIgnoreHidden :: (HasCallStack, MonadIO m, IsSizeGroup a) => a -> Bool -> m ()
- sizeGroupSetMode :: (HasCallStack, MonadIO m, IsSizeGroup a) => a -> SizeGroupMode -> m ()
- constructSizeGroupIgnoreHidden :: (IsSizeGroup o, MonadIO m) => Bool -> m (GValueConstruct o)
- getSizeGroupIgnoreHidden :: (MonadIO m, IsSizeGroup o) => o -> m Bool
- setSizeGroupIgnoreHidden :: (MonadIO m, IsSizeGroup o) => o -> Bool -> m ()
- constructSizeGroupMode :: (IsSizeGroup o, MonadIO m) => SizeGroupMode -> m (GValueConstruct o)
- getSizeGroupMode :: (MonadIO m, IsSizeGroup o) => o -> m SizeGroupMode
- setSizeGroupMode :: (MonadIO m, IsSizeGroup o) => o -> SizeGroupMode -> m ()

# Exported types

newtype SizeGroup Source #

Memory-managed wrapper type.

Constructors

SizeGroup (ManagedPtr SizeGroup) |

#### Instances

Instances details

Eq SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup Methods (==) :: SizeGroup -> SizeGroup -> Bool Source # (/=) :: SizeGroup -> SizeGroup -> Bool Source #
GObject SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup
ManagedPtrNewtype SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup Methods toManagedPtr :: SizeGroup -> ManagedPtr SizeGroup Source #
TypedObject SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup Methods glibType :: IO GType Source #
HasParentTypes SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup
IsGValue (Maybe SizeGroup) Source # | Convert `SizeGroup` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.SizeGroup Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe SizeGroup -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe SizeGroup) Source #
type ParentTypes SizeGroup Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup type ParentTypes SizeGroup = '[Object, Buildable]

class (GObject o, IsDescendantOf SizeGroup o) => IsSizeGroup o Source #

Type class for types which can be safely cast to `SizeGroup`, for instance with `toSizeGroup`.

#### Instances

Instances details

(GObject o, IsDescendantOf SizeGroup o) => IsSizeGroup o Source # |
Instance details Defined in GI.Gtk.Objects.SizeGroup

toSizeGroup :: (MonadIO m, IsSizeGroup o) => o -> m SizeGroup Source #

Cast to `SizeGroup`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

addChild, addWidget, bindProperty, bindPropertyFull, constructChild, customFinished, customTagEnd, customTagStart, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, parserFinished, ref, refSink, removeWidget, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getData, getIgnoreHidden, getInternalChild, getMode, getName, getProperty, getQdata, getWidgets.

#### Setters

setBuildableProperty, setData, setDataFull, setIgnoreHidden, setMode, setName, setProperty.

## addWidget

sizeGroupAddWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a, IsWidget b) |
=> a | `sizeGroup`: a `SizeGroup`
-> b | `widget`: the `Widget` to add
-> m () |

Adds a widget to a `SizeGroup`. In the future, the requisition of the widget will be determined as the maximum of its requisition and the requisition of the other widgets in the size group. Whether this applies horizontally, vertically, or in both directions depends on the mode of the size group. See `sizeGroupSetMode`.

When the widget is destroyed or no longer referenced elsewhere, it will be removed from the size group.

## getIgnoreHidden

sizeGroupGetIgnoreHidden Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a) |
=> a | `sizeGroup`: a `SizeGroup`
-> m Bool | Returns: `True` if invisible widgets are ignored.

Deprecated: (Since version 3.22)Measuring the size of hidden widgets has not workedreliably for a long time. In most cases, they will report a sizeof 0 nowadays, and thus, their size will not affect the othersize group members. In effect, size groups will always operateas if this property was `True`. Use a `Stack` instead to hidewidgets while still having their size taken into account.

Returns if invisible widgets are ignored when calculating the size.

Since: 2.8

## getMode

sizeGroupGetMode Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a) |
=> a | `sizeGroup`: a `SizeGroup`
-> m SizeGroupMode | Returns: the current mode of the size group.

Gets the current mode of the size group. See `sizeGroupSetMode`.

## getWidgets

sizeGroupGetWidgets Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a) |
=> a | `sizeGroup`: a `SizeGroup`
-> m [Widget] | Returns: a `SList` of widgets. The list is owned by GTK+ and should not be modified.

Returns the list of widgets associated with `sizeGroup`.

Since: 2.10

## new

sizeGroupNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SizeGroupMode | `mode`: the mode for the new size group.
-> m SizeGroup | Returns: a newly created `SizeGroup`

Create a new `SizeGroup`.

## removeWidget

sizeGroupRemoveWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a, IsWidget b) |
=> a | `sizeGroup`: a `SizeGroup`
-> b | `widget`: the `Widget` to remove
-> m () |

Removes a widget from a `SizeGroup`.

## setIgnoreHidden

sizeGroupSetIgnoreHidden Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a) |
=> a | `sizeGroup`: a `SizeGroup`
-> Bool | `ignoreHidden`: whether unmapped widgets should be ignored when calculating the size
-> m () |

Deprecated: (Since version 3.22)Measuring the size of hidden widgets has not workedreliably for a long time. In most cases, they will report a sizeof 0 nowadays, and thus, their size will not affect the othersize group members. In effect, size groups will always operateas if this property was `True`. Use a `Stack` instead to hidewidgets while still having their size taken into account.

Sets whether unmapped widgets should be ignored when calculating the size.

Since: 2.8

## setMode

sizeGroupSetMode Source #

Arguments

:: (HasCallStack, MonadIO m, IsSizeGroup a) |
=> a | `sizeGroup`: a `SizeGroup`
-> SizeGroupMode | `mode`: the mode to set for the size group.
-> m () |

Sets the `SizeGroupMode` of the size group. The mode of the size group determines whether the widgets in the size group should all have the same horizontal requisition (`SizeGroupModeHorizontal`) all have the same vertical requisition (`SizeGroupModeVertical`), or should all have the same requisition in both directions (`SizeGroupModeBoth`).

# Properties

## ignoreHidden

If `True`, unmapped widgets are ignored when determining the size of the group.

Since: 2.8

constructSizeGroupIgnoreHidden :: (IsSizeGroup o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`ignore-hidden`” property. This is rarely needed directly, but it is used by `new`.

getSizeGroupIgnoreHidden :: (MonadIO m, IsSizeGroup o) => o -> m Bool Source #

Get the value of the “`ignore-hidden`” property. When overloading is enabled, this is equivalent to

    get sizeGroup #ignoreHidden

setSizeGroupIgnoreHidden :: (MonadIO m, IsSizeGroup o) => o -> Bool -> m () Source #

Set the value of the “`ignore-hidden`” property. When overloading is enabled, this is equivalent to

    set sizeGroup [ #ignoreHidden := value ]

## mode

No description available in the introspection data.

constructSizeGroupMode :: (IsSizeGroup o, MonadIO m) => SizeGroupMode -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`mode`” property. This is rarely needed directly, but it is used by `new`.

getSizeGroupMode :: (MonadIO m, IsSizeGroup o) => o -> m SizeGroupMode Source #

Get the value of the “`mode`” property. When overloading is enabled, this is equivalent to

    get sizeGroup #mode

setSizeGroupMode :: (MonadIO m, IsSizeGroup o) => o -> SizeGroupMode -> m () Source #

Set the value of the “`mode`” property. When overloading is enabled, this is equivalent to

    set sizeGroup [ #mode := value ]